Index: issm/trunk/src/c/classes/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Penta.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Penta.cpp	(revision 13975)
@@ -7817,17 +7861,16 @@
 ElementVector* Penta::CreatePVectorDiagnosticVertBase(void){
 
-
 	/*Constants*/
 	const int    numdof=NDOF1*NUMVERTICES;
 
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	int        approximation;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     xyz_list_tria[NUMVERTICES2D][3];
-	IssmDouble     Jdet2d;
-	IssmDouble     vx,vy,vz,dbdx,dbdy,basalmeltingvalue;
-	IssmDouble     slope[3];
-	IssmDouble     basis[NUMVERTICES];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble xyz_list_tria[NUMVERTICES2D][3];
+	IssmDouble Jdet2d;
+	IssmDouble vx,vy,vz,dbdx,dbdy,basalmeltingvalue;
+	IssmDouble slope[3];
+	IssmDouble basis[NUMVERTICES];
 	GaussPenta* gauss=NULL;
 
@@ -7852,5 +7895,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(0,1,2,2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -7940,14 +7983,13 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
-	IssmDouble     eps1[3],eps2[3];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[3][NUMVERTICES];
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
+	IssmDouble eps1[3],eps2[3];
+	IssmDouble dphi[3][NUMVERTICES];
 	GaussPenta *gauss=NULL;
 
@@ -7962,5 +8004,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(5,5);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -8005,15 +8047,14 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     eps3dotdphii,eps3dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
-	IssmDouble     eps1[3],eps2[3],eps3[3];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[3][NUMVERTICES];
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble eps3dotdphii,eps3dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[5]; /* epsilon=[exx,eyy,exy,exz,eyz];*/
+	IssmDouble eps1[3],eps2[3],eps3[3];
+	IssmDouble dphi[3][NUMVERTICES];
 	GaussPenta *gauss=NULL;
 
@@ -8029,5 +8070,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussPenta(5,5);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -8416,5 +8457,5 @@
 		penta=penta->GetUpperElement(); _assert_(penta->Id()!=this->id);
 	}
-	
+
 	/*Free ressources:*/
 	xDelete<int>(doflist);
@@ -8688,5 +8729,5 @@
 /*FUNCTION Penta::InputUpdateFromSolutionDiagnosticPattyn {{{*/
 void  Penta::InputUpdateFromSolutionDiagnosticPattyn(IssmDouble* solution){
-	
+
 	const int    numdof=NDOF2*NUMVERTICES;
 
@@ -8856,5 +8897,5 @@
 /*FUNCTION Penta::InputUpdateFromSolutionDiagnosticHutter {{{*/
 void  Penta::InputUpdateFromSolutionDiagnosticHutter(IssmDouble* solution){
-	
+
 	const int    numdof=NDOF2*NUMVERTICES;
 
@@ -8921,5 +8962,5 @@
 
 	const int numdof=NDOF1*NUMVERTICES;
-	
+
 	int      i;
 	int      approximation;
@@ -8938,5 +8979,4 @@
 	int*     doflist      = NULL;
 
-
 	/*Get the approximation and do nothing if the element in Stokes or None*/
 	inputs->GetInputValue(&approximation,ApproximationEnum);
@@ -9023,5 +9063,5 @@
 /*FUNCTION Penta::InputUpdateFromSolutionDiagnosticStokes {{{*/
 void  Penta::InputUpdateFromSolutionDiagnosticStokes(IssmDouble* solution){
-	
+
 	const int numdof=NDOF4*NUMVERTICES;
 
@@ -9063,5 +9103,5 @@
 	for(i=0;i<NUMVERTICES;i++) pressure[i]=pressure[i]*stokesreconditioning;
 	for(i=0;i<NUMVERTICES;i++) vel[i]=pow( pow(vx[i],2.0) + pow(vy[i],2.0) + pow(vz[i],2.0) , 0.5);
-	
+
 	/*Now, we have to move the previous inputs  to old 
 	 * status, otherwise, we'll wipe them off: */
@@ -9133,3 +9173,2 @@
 /*}}}*/
 #endif
-
Index: issm/trunk/src/c/classes/objects/Elements/Penta.h
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Penta.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Penta.h	(revision 13975)
@@ -34,13 +34,13 @@
 		int          sid;
 
-		Node       **nodes;        // 6 nodes
-		Material    *material;       // 1 material ice
-		Matpar      *matpar;       // 1 material parameter
-		Penta      **verticalneighbors;   // 2 neighbors: first one under, second one above
+		Node       **nodes;                       // 6 nodes
+		Material    *material;                    // 1 material ice
+		Matpar      *matpar;                      // 1 material parameter
+		Penta      **verticalneighbors;           // 2 neighbors: first one under, second one above
 		int          horizontalneighborsids[3];
 
-		Parameters  *parameters;   //pointer to solution parameters
+		Parameters  *parameters;                  //pointer to solution parameters
 		Inputs      *inputs;
-		Results      *results;
+		Results     *results;
 
 		/*Penta constructors and destructor: {{{*/
@@ -50,10 +50,9 @@
 		/*}}}*/
 		/*Object virtual functions definitions: {{{*/
-		Object*   copy();
-		void	  DeepEcho();
-		void	  Echo();
-		int		  ObjectEnum();
-		int		  Id(); 
-		int		  MyRank();
+		Object *copy();
+		void    DeepEcho();
+		void    Echo();
+		int     ObjectEnum();
+		int     Id();
 		/*}}}*/
 		/*Update virtual functions definitions: {{{*/
@@ -81,4 +80,5 @@
 		void   Configure(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters);
 		void   SetCurrentConfiguration(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters);
+		void   SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		void   CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,Vector<IssmDouble>* df);
 		void   CreatePVector(Vector<IssmDouble>* pf);
@@ -87,9 +87,11 @@
 		void   DeleteResults(void);
 		int    GetNodeIndex(Node* node);
+		void   GetNodesSidList(int* sidlist);
+		int    GetNumberOfNodes(void);
 		void   GetSolutionFromInputs(Vector<IssmDouble>* solution);
 		IssmDouble GetZcoord(GaussPenta* gauss);
 		void   GetVectorFromInputs(Vector<IssmDouble>* vector,int name_enum);
 		void   GetVectorFromResults(Vector<IssmDouble>* vector,int offset,int name_enum,int interp);
-		
+
 		int    Sid();
 		void   InputArtificialNoise(int enum_type,IssmDouble min, IssmDouble max);
@@ -100,5 +102,5 @@
 		void   InputDuplicate(int original_enum,int new_enum);
 		void   InputScale(int enum_type,IssmDouble scale_factor);
-		
+
 		void   InputToResult(int enum_type,int step,IssmDouble time);
 		void   MigrateGroundingLine(IssmDouble* old_floating_ice,IssmDouble* sheet_ungrounding);
@@ -174,6 +176,6 @@
 		ElementVector* CreatePVectorSlope(void);
 		void	  GetDofList(int** pdoflist,int approximation_enum,int setenum);
-		void	  GetDofList1(int* doflist);
-		void    GetSidList(int* sidlist);
+		void	  GetVertexPidList(int* doflist);
+		void    GetVertexSidList(int* sidlist);
 		void    GetConnectivityList(int* connectivity);
 		int     GetElementType(void);
Index: issm/trunk/src/c/classes/objects/Elements/PentaHook.h
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/PentaHook.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/PentaHook.h	(revision 13975)
@@ -13,21 +13,19 @@
 
 	public: 
-		int   numanalyses; //number of analysis types
-		Hook** hnodes; // 6 nodes for each analysis type
-		Hook*  hmaterial; // 1 ice material
-		Hook*  hmatpar; // 1 material parameter
-		Hook*  hneighbors; // 2 elements, first down, second up
+		int    numanalyses;   //number of analysis types
+		Hook **hnodes;        // 6 nodes for each analysis type
+		Hook  *hmaterial;     // 1 ice material
+		Hook  *hmatpar;       // 1 material parameter
+		Hook  *hneighbors;    // 2 elements, first down, second up
 
-		/*FUNCTION constructors, destructors {{{*/
+		/*constructors, destructors*/
 		PentaHook();
 		PentaHook(int in_numanalyses,int material_id, IoModel* iomodel);
 		~PentaHook();
+
 		void SetHookNodes(int* node_ids,int analysis_counter);
 		void SpawnTriaHook(TriaHook* triahook,int* indices);
 		void InitHookNeighbors(int* element_ids);
-		/*}}}*/
 };
 
-
 #endif //ifndef _PENTAHOOK_H_
-
Index: issm/trunk/src/c/classes/objects/Elements/PentaRef.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/PentaRef.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/PentaRef.cpp	(revision 13975)
@@ -699,5 +699,4 @@
 	IssmDouble l1l2l3[NUMNODESP1_2d];
 
-
 	/*Get l1l2l3 in actual coordinate system: */
 	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
@@ -812,5 +811,4 @@
 	IssmDouble l1l2l3[NUMNODESP1_2d];
 
-
 	/*Get l1l2l3 in actual coordinate system: */
 	l1l2l3[0]=gauss->coord1*(1-gauss->coord4)/2.0;
@@ -882,6 +880,4 @@
 void PentaRef::GetJacobian(IssmDouble* J, IssmDouble* xyz_list,GaussPenta* gauss){
 
-	int i,j;
-
 	/*The Jacobian is constant over the element, discard the gaussian points. 
 	 * J is assumed to have been allocated of size NDOF2xNDOF2.*/
@@ -899,7 +895,7 @@
 	A3=gauss->coord3;
 
-	xi=A2-A1;
-	eta=SQRT3*A3;
-	zi=gauss->coord4;
+	xi  = A2-A1;
+	eta = SQRT3*A3;
+	zi  = gauss->coord4;
 
 	x1=*(xyz_list+3*0+0);
